//+----------------------------------------------------------------------------+
//|                                                       i-SignalOfTrade.mq4  |
//|                                                      . aka KimIV  |
//|                                                       http://www.kimiv.ru  |
//|                                                                            |
//|  05.12.2007     .                    |
//+----------------------------------------------------------------------------+

//| Erklrung Alexander Piechotta 13.01.2008 - openreal@gmx.de
//| http://www.elitetrading.de/forum/software/metatrader_signal_der_order_4078.html

#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"

#property indicator_chart_window

//-------    ----------------------------------------+
extern string _P_WhatOutput    = "---------- Zusatz Signale";
extern bool   OutAccountNumber = True;      //   
extern bool   OutAccountServer = True;      //    
extern bool   OutNameExpert    = True;      //   
extern bool   OutDateTime      = True;      //    
extern bool   UseTimeLocal     = True;      //   
extern bool   OutTicket        = False;     //  
extern bool   OutMagic         = True;      //  
extern bool   OutComment       = True;      //  
extern string _P_WhereOutput    = "---------- Signal-Arten";
extern bool   UseAlert    = True;           //   
extern bool   UseComment  = True;           //  
extern bool   UsePrint    = False;          //   
extern bool   UseSendMail = False;          //   
extern bool   UseSound    = True;           //  
extern string FileName    = "expert.wav";   //   

//-------    ------------------------------------+
int    bsmOTI[];             //    OrderTicket()
int    bsmOTY[];             //      OrderType()
double bsmOOP[];             //     OrderOpenPrice()
double bsmOSL[];             //     OrderStopLoss()
double bsmOTP[];             //     OrderTakeProfit()
bool   bsmFirstRun=True;     //   


//+----------------------------------------------------------------------------+
//|                                                                            |
//|  ˨                                                   |
//|                                                                            |
//+----------------------------------------------------------------------------+
//|  Custom indicator initialization function                                  |
//+----------------------------------------------------------------------------+
void init() {
  bsmFirstRun=True;     //   
  Comment("");
}

//+----------------------------------------------------------------------------+
//|  Custom indicator deinitialization function                                |
//+----------------------------------------------------------------------------+
void deinit() { Comment(""); }

//+----------------------------------------------------------------------------+
//|  Custom indicator iteration function                                       |
//+----------------------------------------------------------------------------+
void start() {
  double p;                  //     
  int    d;                  //       
  int    i;                  //  
  int    in;                 //    
  int    k=OrdersTotal();    //   
  int    ot;                 //   OrderType()
  int    oti[];              //   
  string sh="";              //    
  string st;                 //    

  if (bsmFirstRun) { MemCurrOP(); bsmFirstRun=False; }
  if (OutAccountNumber) sh=DoubleToStr(AccountNumber(), 0)+" ";
  if (OutAccountServer) sh=sh+AccountServer();
  if (StringLen(sh)>0) sh=sh+"\n";
  if (OutDateTime) {
    if (UseTimeLocal) sh=sh+TimeToStr(TimeLocal(), TIME_DATE|TIME_MINUTES)+" ";
    else sh=sh+TimeToStr(TimeCurrent(), TIME_DATE|TIME_SECONDS)+" ";
  }
  if (OutNameExpert) sh=sh+WindowExpertName()+" ";
  if (StringLen(sh)>0) sh=sh+"\n";
  
  // / ,  
  ArrayResize(oti, k);
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      oti[i]=OrderTicket();
      d=MarketInfo(OrderSymbol(), MODE_DIGITS);
      p=MarketInfo(OrderSymbol(), MODE_POINT);
      in=ArraySearchInt(bsmOTI, oti[i]);

      //   ,  
      if (in<0) {
        ot=OrderType();
        if (ot==OP_BUY || ot==OP_SELL) st="Open ";
        if (ot==OP_BUYLIMIT || ot==OP_BUYSTOP
        ||  ot==OP_SELLLIMIT || ot==OP_SELLSTOP) st="Set ";
        if (OutTicket) st=st+DoubleToStr(OrderTicket(), 0)+" ";
        st=st+GetNameOP(ot)+" "
             +DoubleToStr(OrderLots(), 2)+" "
             +OrderSymbol()
             +" PR="+DoubleToStr(OrderOpenPrice(), d)
             +" SL="+DoubleToStr(OrderStopLoss(), d)
             +" TP="+DoubleToStr(OrderTakeProfit(), d)
             +"\n"
             +IIFs(OutMagic, "Magic="+DoubleToStr(OrderMagicNumber(), 0), "")
             +IIFs(OutMagic && OutComment, " ", "")
             +IIFs(OutComment, "Comment=\""+OrderComment()+"\"", "")
             +IIFs(OutMagic || OutComment, "\n", "");
        if (ot==OP_BUY || ot==OP_SELL) {
          st=st+"Balance="+DoubleToStr(AccountBalance(), 2)
               +" FreeMargin="+DoubleToStr(AccountFreeMargin(), 2);
        }
        if (StringLen(sh)>0) st=sh+st;
        Signal(st);

      //  ,      
      } else {
        if ((MathAbs(OrderOpenPrice()-bsmOOP[in])>=p)
        ||  (MathAbs(OrderStopLoss()-bsmOSL[in])>=p)
        ||  (MathAbs(OrderTakeProfit()-bsmOTP[in])>=p)) {
          st="Modify ";
          if (OutTicket) st=st+DoubleToStr(OrderTicket(), 0)+" ";
          st=st+GetNameOP(OrderType())+" "
            +DoubleToStr(OrderLots(), 2)+" "
            +OrderSymbol();
          //   
          if (MathAbs(OrderOpenPrice()-bsmOOP[in])>=p) {
            st=st+" PR="+DoubleToStr(bsmOOP[in], d)+"->"+DoubleToStr(OrderOpenPrice(), d);
          }
          //   
          if (MathAbs(OrderStopLoss()-bsmOSL[in])>=p) {
            st=st+" SL="+DoubleToStr(bsmOSL[in], d)+"->"+DoubleToStr(OrderStopLoss(), d);
          }
          //   
          if (MathAbs(OrderTakeProfit()-bsmOTP[in])>=p) {
            st=st+" TP="+DoubleToStr(bsmOTP[in], d)+"->"+DoubleToStr(OrderTakeProfit(), d);
          }
          st=st+IIFs(OutMagic || OutComment, "\n", "")
               +IIFs(OutMagic, "Magic="+DoubleToStr(OrderMagicNumber(), 0), "")
               +IIFs(OutMagic && OutComment, " ", "")
               +IIFs(OutComment, "Comment=\""+OrderComment()+"\"", "")
               +IIFs(OutMagic || OutComment, "\n", "");
          if (StringLen(sh)>0) st=sh+st;
          Signal(st);
        }
      }
    }
  }

  //   /  
  k=ArraySize(bsmOTI);
  for (i=0; i<k; i++) {
    if (ArraySearchInt(oti, bsmOTI[i])<0) {
      ot=bsmOTY[i];
      if (ot==OP_BUY || ot==OP_SELL) st="Close ";
      if (ot==OP_BUYLIMIT || ot==OP_BUYSTOP
      ||  ot==OP_SELLLIMIT || ot==OP_SELLSTOP) st="Delete ";
      if (OutTicket) st=st+DoubleToStr(bsmOTI[i], 0)+" ";
      if (SelectByTicketFromHistory(bsmOTI[i])) {
        d=MarketInfo(OrderSymbol(), MODE_DIGITS);
        st=st+GetNameOP(ot)+" "
             +DoubleToStr(OrderLots(), 2)+" "
             +OrderSymbol()
             +" PR="+DoubleToStr(OrderClosePrice(), d)
             ;
        if (ot==OP_BUY || ot==OP_SELL) {
          st=st+" Profit="+DoubleToStr(OrderProfit()+OrderSwap(), 2)
               +"\n"
               +IIFs(OutMagic, "Magic="+DoubleToStr(OrderMagicNumber(), 0), "")
               +IIFs(OutMagic && OutComment, " ", "")
               +IIFs(OutComment, "Comment=\""+OrderComment()+"\"", "")
               +IIFs(OutMagic || OutComment, "\n", "")
               +"Balance="+DoubleToStr(AccountBalance(), 2)
               +" FreeMargin="+DoubleToStr(AccountFreeMargin(), 2);
        }
        if (StringLen(sh)>0) st=sh+st;
        Signal(st);
      }
    }
  }

  MemCurrOP();
}


//+----------------------------------------------------------------------------+
//|                                                                            |
//|                                                     |
//|                                                                            |
//+----------------------------------------------------------------------------+
//|                                     |
//|        -1                            |
//|  :                                                                |
//|    m -                                                      |
//|    e -                                                     |
//+----------------------------------------------------------------------------+
int ArraySearchInt(int& m[], int e) {
  for (int i=0; i<ArraySize(m); i++) {
    if (m[i]==e) return(i);
  }
  return(-1);
}

//+----------------------------------------------------------------------------+
//|                                      |
//|  :                                                                |
//|    op -                                       |
//+----------------------------------------------------------------------------+
string GetNameOP(int op) {
	switch (op) {
		case OP_BUY      : return("Buy");
		case OP_SELL     : return("Sell");
		case OP_BUYLIMIT : return("Buy Limit");
		case OP_SELLLIMIT: return("Sell Limit");
		case OP_BUYSTOP  : return("Buy Stop");
		case OP_SELLSTOP : return("Sell Stop");
		default          : return("Unknown Operation");
	}
}

//+----------------------------------------------------------------------------+
//|         .                 |
//+----------------------------------------------------------------------------+
string IIFs(bool condition, string ifTrue, string ifFalse) {
  if (condition) return(ifTrue); else return(ifFalse);
}

//+----------------------------------------------------------------------------+
//|      .                                    |
//+----------------------------------------------------------------------------+
void MemCurrOP() {
  int i, k=OrdersTotal();

  ArrayResize(bsmOTI, k);
  ArrayResize(bsmOTY, k);
  ArrayResize(bsmOOP, k);
  ArrayResize(bsmOSL, k);
  ArrayResize(bsmOTP, k);
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      bsmOTI[i]=OrderTicket();
      bsmOTY[i]=OrderType();
      bsmOOP[i]=OrderOpenPrice();
      bsmOSL[i]=OrderStopLoss();
      bsmOTP[i]=OrderTakeProfit();
    }
  }
}

//+----------------------------------------------------------------------------+
//|                       |
//|  :                                                                |
//|    ti -  ,                                               |
//|    sy -     ("" -  )                   |
//|    op -                    (-1 -  )                    |
//|    mn - MagicNumber                (-1 -  )                      |
//+----------------------------------------------------------------------------+
bool SelectByTicketFromHistory(int ti, string sy="", int op=-1, int mn=-1) {
  int i, k=OrdersHistoryTotal();

  if (sy=="") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
      if (OrderSymbol()==sy && (op<0 || OrderType()==op)) {
        if ((mn<0 || OrderMagicNumber()==mn) && OrderTicket()==ti) return(True);
      }
    }
  }
  return(False);
}

//+----------------------------------------------------------------------------+
//|   .                                                           |
//|  :                                                                |
//|    st -                                                     |
//+----------------------------------------------------------------------------+
void Signal(string st) {
  if (UseAlert) Alert(st);
  if (UseComment) Comment(st);
  if (UseSendMail) SendMail(WindowExpertName(), st);
  if (UsePrint) Print(st);
  if (UseSound) PlaySound(FileName);
}
//+----------------------------------------------------------------------------+

